//JOHN PALMISANO		4-9-2004

//CODE WRITTEN FOR T2 for MOBOT with autoconfig

//for cmucam go to http://www-2.cs.cmu.edu/~cmucam/Downloads/CMUcamManual.pdf



#include "jsp2Util.h"

#include "sercomm.h"

#include <stdlib.h>

#include "IRalerts.h"//for redchase only



int gatecounter=0;

/*

//gatecounter interrupt

#int_EXT

EXT_isr()

{

gatecounter++;

}

*/



/*#int_RB

RB_isr()

{

gatecounter++;

}*/



//change program

int mode=0;//0 for mobot, 1 for redchase



//parses M packets for TC command

void parseCameraInput(char* inpString,  int &mx,  int &my,  int &x1,  int &x2,  int &y1,  int &y2,  int &fps,  int &confidence)

{

    int i = 2;

    

    mx = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    my = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    x1 = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    y1 = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    x2 = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    y2 = ( int)atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    fps = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    confidence = atoi(&inpString[i]);



}



//parses S packets for GM command

void parseSpacket(char* inpString,  int &rmean,  int &gmean,  int &bmean,  int &rdev,  int &gdev,  int &bdev)

{

    int i = 2;

    

    rmean = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    gmean = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    bmean = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    rdev = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    gdev = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    bdev = atoi(&inpString[i]);

}



void main()

{

    //cam variables

    char stringFromCamera[20];//dont change this array size makes weird things happen if u do

    char characterFromCamera;

    int mx, my, x1, x2, y1, y2, fps, confidence;//M packets

    int rmean, gmean, bmean, rdev, gdev, bdev;//S packets

    

    //movement variables

    signed int TL=0, TR=0, BL=0, BR=0;//wheel angles

    int speed=100, velLeft=0, velRight=0;//speeds

    //angle and velocity variables

    signed int theta=0;//theta to object detected

    int i=0, j=0, k=0;

    //gatecounting variables

    int gatepassed=0;

    signed int gatemod=0;//gives line split choice to go which way



    //IR values

    int thresh=100;

    int state=0;



    //initialization

    cereb_init();

    straighten();



    output_high(PIN_B4);

    output_high(PIN_B5);

    

     /*values to send with the cr command

     5   Contrast    0-255

     6   Brightness  0-255

     18  Color Mode

     36  YCrCb*  Auto White Balance On

     32  YCrCb* Auto White Balance Off

     44  RGB  Auto White Balance On

     40  RGB  Auto White Balance Off   (default)

     17  Clock Speed                 

                  2     17 fps   (default)

                  3     13 fps

                  4     11 fps

                  5     9  fps

     19  Auto Exposure          

     32  Auto Gain Off  

     33  Auto Gain On  (default)  

    */

    

    //reset camera

    ser_tx("\r");

    delay_ms(200);

    

    //turn off autowhite balance, let autogain stay on for a few seconds, set clock to 13fps

    printf("CR 18 40 19 33 17 3\r");

    if (mode==0)//mobot

    	delay_ms(15000);//use 15000

    if (mode==1)//redchase

    	delay_ms(10000);

    

    //setting camera regs

    printf("CR 19 32 5 255\r");//RBG auto gain off, max contrast

    delay_ms(30);



    output_low(PIN_B4);



    //set a delay for each value from the camera

    //Each delay unit correlates to approximately the

    //transfer time of one bit at the current baud rate. 

    printf("DM 1\r");

    delay_ms(20);

    

    //get mean values for green and blue

    printf("GM\r");

    delay_ms(1700);

    while(j!=3)//getting mean a few times to ensure accuracy, sometimes blows up with values above 3!!!

    {

	while(1)//fills array up with goodies

		{

	  	characterFromCamera = ser_rx();

	  	if(characterFromCamera == '\r')

	  	    {

	  	    stringFromCamera[i]='\0';

	  	    break;

	  	    }

	  	stringFromCamera[i] = characterFromCamera;

	  	i++;

	  	}

	j++;

    }

    

    printf("\r");//stop GM

    parseSpacket(stringFromCamera, rmean, gmean, bmean, rdev, gdev, bdev);//store S packet

    delay_ms(20);

    

    //artificially change mean values cause of freaky sun effects

    if (mode==0)//mobot

	{

	if (gmean>(16+11))

		gmean=gmean-11;//11

	if (bmean>(16+11))

		bmean=bmean-11;//11

	}

    if (mode==1)//redchase

	{

	if (gmean>(16+11))

		gmean=gmean-8;

	if (bmean>(16+11))

		bmean=bmean-8;

	}



    //TRACKING COLOR  (color min=16, color max=240)

    //bright red: 100 240 16 100 16 80

    //go here to get color numbers: http://noz.day-break.net/webcolor/red.html

    //declares color to track

    if (mode==0)//mobot

    	printf("TC 0 255 %u 255 %u 255\r",gmean,bmean);

    if (mode==1)//redchase

	printf("TC %u 255 0 100 0 80\r",rmean);

    

    delay_ms(20);

    output_low(PIN_B5);

    

  while(1)//code below here only

  { 

    i=0;

  	while(1)

  		{

  		characterFromCamera = ser_rx();

  		if(characterFromCamera == '\r')

  			{

	  		stringFromCamera[i]='\0';

	  		break;

	  		}

	  	stringFromCamera[i] = characterFromCamera;

	  	i++;

	  	}

 	parseCameraInput(stringFromCamera, mx, my, x1, x2, y1, y2, fps, confidence);

    

    //NOTE: 80x143 Resolution

    //NOTE: resolution with line mode is 80x48

    //NOTE: THE CAMERA IS BACKWARDS!!!! so 80->1 x axis (left->right)

    //NOTE: THE CAMERA IS BACKWARDS!!!! so 143->1 y axis (top->bottom)

    //NOTE: camera doesnt work at x,y=0

    

    ///*gate code here

    if (gatecounter==1)//8th gate, starting from 0//stay right

    	gatemod=+6;

    if (gatecounter==2)//go straight on right

    	gatemod=-6;

    if (gatecounter==3)//left then right

    	{

    	LEDon(green);

    	motors(0,0);//go forward for awhile

    	straighten();

    	motors(100,100);

    	delay_ms(2000);

    	motors(0,0);

    	spin();//rotate

    	motors(-100,100);

    	delay_ms(800);

    	motors(0,0);

    	straighten();//go forward for awhile

    	motors(100,100);

    	delay_ms(4500);

    	motors(0,0);

    	spin();//rotate

    	motors(100,-100);

    	delay_ms(700);

    	motors(0,0);//now continue original loop

    	LEDoff(green);

    	gatecounter++;

	}

    if (gatecounter==5)//right then left

    	gatemod=+8;

    if (gatecounter==6)//left then right

    	gatemod=-8;

    if (gatecounter==7)//stay straight on left to finish line

    	gatemod=-8;

    	

	//calculate angle to turn to

	//almost a 1:1 ratio (positive->left, negative->right

       theta=mx-40-2+gatemod;//-2 because cam is misaligned

    	

    	//gate counter code -> redo circuit so i can set this as an interrupt yo!

    	if (analog(A0)>(200) && gatepassed==0)//dependent on resistor and cap choice

    		{

    		gatecounter++;

    		gatepassed=1;

    		delay_ms(5);//cheap hack debouncer

    		}

    	else if (analog(A0)<(100))

    		gatepassed=0;

    	//disable_interrupts(INT_xxxx);//use to turn on and off the timer interrupt

    	

    	

    	///////////////begin calculate wheel angles/speeds code

	if (theta>2)//object on left

	  	{

	  	//calculating angles

	  	TL=theta*3/2;//atan(y/(d/turnconst));

	  	TR=theta;//atan(y/((d+x)/turnconst));

	  	BL=-TL;

	  	BR=-TR;

	  	

	  	velLeft=speed-abs(theta)+3;//inner wheel velocity

	  	velRight=speed;//outer wheel velocity

		}

	

	else if (theta<-2)//object on right

	  	{

	  	//calculating angles

	  	TL=theta;//atan(y/((d+x)/turnconst));

	  	TR=theta*3/2;//atan(y/(d/turnconst));

	  	BL=-TL;

	  	BR=-TR;

	  	

	  	velLeft=speed;//outer wheel velocity

	  	velRight=speed-abs(theta)+3;//inner wheel velocity

		}

		

	else if (theta<3 && theta>-3)//object centered

		{

		TL=0;

		TR=0;

		BL=0;

		BR=0;

		

		velLeft=speed;

		velRight=speed;

		}

	

	///////////////end calculate wheel angles/speeds code

    	

    	/*

    	//gate counting test code -> blinks green LED for each count

    	LEDon(yellow);

    	delay_ms(500);

    	for (k=0;k<gatecounter;k++)

    	{

    		LEDon(green);

    		delay_ms(500);

    		LEDoff(green);

    		delay_ms(500);

    	}

    	LEDoff(yellow);

    	delay_ms(500);*/

    	

	steer(TL,TR,BL,BR);

	motors(velLeft,velRight);

	

    	if (mode==1)//for redchase only

    		{

    		state=getstate(thresh);

    		if (state>0)

    			{

    			motors(-100,-100);

    			delay_ms(1000);

    			}

    		if (state==100 || state==110 || state==111)

    			{

    			spin();

			motors(100,-100);

			delay_ms(1900);

    			}

    		else if (state==11 || state==1)

    			{

    			spin();

			motors(-100,100);

			delay_ms(1900);

    			}

    		}

	}

}