//JOHN PALMISANO		1-19-2004

//CODE WRITTEN FOR T2 for MOBOT with autoconfig

//for cmucam go to http://www-2.cs.cmu.edu/~cmucam/Downloads/CMUcamManual.pdf



#include "jsp2Util.h"

#include "sercomm.h"

#include <stdlib.h>



void parseCameraInput(char* inpString,  int &mx,  int &my,  int &x1,  int &x2,  int &y1,  int &y2,  int &fps,  int &confidence)

{

    int i = 2;

    

    mx = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    my = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    x1 = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    y1 = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    x2 = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    y2 = ( int)atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    fps = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    confidence = atoi(&inpString[i]);



}



//parses S packets for GM command

void parseSpacket(char* inpString,  int &rmean,  int &gmean,  int &bmean,  int &rdev,  int &gdev,  int &bdev)

{

    int i = 2;

    

    rmean = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    gmean = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    bmean = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    rdev = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    gdev = atoi(&inpString[i]);

    while(inpString[i]!=' ')

    {

        i++;

    }

    i++;

    bdev = atoi(&inpString[i]);

}



void main()

{

    //cam variables

    char stringFromCamera[20];//dont change this array size makes weird things happen if u do

    char characterFromCamera;

    int mx, my, x1, x2, y1, y2, fps, confidence;//M packets

    int rmean, gmean, bmean, rdev, gdev, bdev;//S packets

    

    //movement variables

    signed int TL=0, TR=0, BL=0, BR=0;//wheel angles

    int speed=30, velLeft=0, velRight=0;//speeds

    //angle and velocity variables

    signed int theta=0;//theta to object detected

    int i=0, j=0;



    //initialization

    cereb_init();

    straighten();



    output_high(PIN_B4);

    output_high(PIN_B5);

    

     /*values to send with the cr command

     5   Contrast    0-255 

     6   Brightness    0-255  

     18 Color Mode           

     36     YCrCb*  Auto White Balance On  

     32     YCrCb* Auto White Balance Off  

     44     RGB  Auto White Balance On                                      

     40     RGB  Auto White Balance Off   (default)  

     17 Clock Speed                 

                  2         17 fps   (default) 

                  3         13 fps    

                  4         11 fps   

                  5         9  fps  

                  6         8  fps  

                  7         7  fps  

                  8         6  fps  

                  10        5  fps  

                  12        4  fps  

     19 Auto Exposure          

     32       Auto Gain Off  

     33       Auto Gain On  (default)  

    */

    

    //reset camera

    ser_tx("\r");

    delay_ms(200);

    

    //turn off autowhite balance, let autogain stay on for a few seconds, set clock to 13fps

    printf("CR 18 40 19 33 17 3\r");

    delay_ms(5000);

    

    //setting camera regs

    printf("CR 19 32 5 255\r");//RBG auto gain off, max contrast

    delay_ms(30);



    output_low(PIN_B4);

    

/*  //LM DOESNT WORK

    //setting line mode

    //NOTE: resolution with line mode is 80x48

    printf("LM 1\r");//line mode on seems to blow things up

    //delay_ms(30);

  	while(1)

  	{

  	    characterFromCamera = ser_rx();

  	    if(characterFromCamera == ':')

  	    {

  	        break;

  	    }

  	}

*/



    //set a delay for each value from the camera

    //Each delay unit correlates to approximately the

    //transfer time of one bit at the current baud rate. 

    printf("DM 1\r");

    delay_ms(20);

    

    //get mean values for green and blue

    printf("GM\r");

    delay_ms(1500);

    while(j!=3)//getting mean a few times to ensure accuracy, sometimes blows up with values above 3!!!

    {

	while(1)//fills array up with goodies

		{

	  	characterFromCamera = ser_rx();

	  	if(characterFromCamera == '\r')

	  	    {

	  	        stringFromCamera[i]='\0';

	  	        break;

	  	    }

	  	    stringFromCamera[i] = characterFromCamera;

	  	    i++;

	  	}

	j++;

    }

    

    printf("\r");//stop GM

    parseSpacket(stringFromCamera, rmean, gmean, bmean, rdev, gdev, bdev);//store S packet

    delay_ms(20);

    

    //artificially change mean values cause of freaky sun effects

    gmean=gmean-11;

    bmean=bmean-11;

    

    //TRACKING COLOR

    //bright red: 100 255 0 100 0 80

    //go here to get color numbers: http://noz.day-break.net/webcolor/red.html

    //declares color to track

    printf("TC 0 245 %u 245 %u 245\r",gmean,bmean);

    delay_ms(20);



    output_low(PIN_B5);

    

  while(1)//code below here only

  { 

    i=0;



  	while(1)

  	{

  	    characterFromCamera = ser_rx();

  	    if(characterFromCamera == '\r')

  	    {

  	        stringFromCamera[i]='\0';

  	        break;

  	    }

  	        

  	    stringFromCamera[i] = characterFromCamera;

  	    i++;

  	}

  	

       parseCameraInput(stringFromCamera, mx, my, x1, x2, y1, y2, fps, confidence);

    

    //NOTE: 80x143 Resolution

    //NOTE: resolution with line mode is 80x48

    //NOTE: THE CAMERA IS BACKWARDS!!!! so 80->1 x axis (left->right)

    //NOTE: THE CAMERA IS BACKWARDS!!!! so 143->1 y axis (top->bottom)

    //NOTE: camera doesnt work at x,y=0



       theta=mx-40-3;//almost a 1:1 ratio

    

    	///////////////begin calculate wheel angles/speeds code

	if (theta>2)//object on left

	  	{

	  	//calculating angles

	  	TL=theta/2*3;//atan(y/(d/turnconst));

	  	TR=theta;//atan(y/((d+x)/turnconst));

	  	BL=-TL;

	  	BR=-TR;

	  	

	  	LEDon(green);

	  	LEDoff(yellow);

	  	

	  	//velLeft=(speed*x)/(d+x);//inner wheel velocity

	  	velLeft=speed-abs(theta)+3;//inner wheel velocity

	  	velRight=speed;//outer wheel velocity

		}

	

	else if (theta<-2)//object on right

	  	{

	  	//calculating angles

	  	TL=theta;//atan(y/((d+x)/turnconst));

	  	TR=theta/2*3;//atan(y/(d/turnconst));

	  	BL=-TL;

	  	BR=-TR;

	  		  	

	  	LEDoff(green);

	  	LEDon(yellow);

	  	

	  	velLeft=speed;//inner wheel velocity

	  	velRight=speed-abs(theta)+3;//outer wheel velocity

	  	//velRight=(speed*x)/(d+x);//outer wheel velocity

		}

		

	else//object centered

		{

		TL=0;

		TR=0;

		BL=0;

		BR=0;

			  	

	  	LEDon(green);

	  	LEDon(yellow);

		

		velLeft=speed;

		velRight=speed;

		}

	///////////////end calculate wheel angles/speeds code

    	

	steer(TL,TR,BL,BR);

	motors(velLeft,velRight);



}



  while(1);

}